# Record Class LLUser

java.lang.Object
java.lang.Record
com.io7m.looseleaf.security.LLUser

Record Components:
  `name` - The user's name
  `password` - The user's hashed password
  `roles` - The user's roles

public record LLUser(LLUserName name, LLPassword password, Map<LLRoleName,LLRole> roles) extends Record
A user.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LLUser(LLUserName name, LLPassword password, Map<LLRoleName,LLRole> roles)`
  A user.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `allows(LLAction action, LLKeyName keyName)`
  Determine if the user is permitted to perform the given action on the given key.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `LLUserName`
  `name()`
  Returns the value of the `name` record component.
  `LLPassword`
  `password()`
  Returns the value of the `password` record component.
  `Map<LLRoleName,LLRole>`
  `roles()`
  Returns the value of the `roles` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### LLUser

    public LLUser(LLUserName name, LLPassword password, Map<LLRoleName,LLRole> roles)
    A user.
    Parameters:
      `name` - The user's name
      `password` - The user's hashed password
      `roles` - The user's roles

- ## Method Details

  - ### allows

    public boolean allows(LLAction action, LLKeyName keyName)
    Determine if the user is permitted to perform the given action on the given key.
    Parameters:
      `action` - The action
      `keyName` - The key
    Returns:
      `true` if the action is permitted

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public LLUserName name()
    Returns the value of the `name` record component.
    Returns:
      the value of the `name` record component

  - ### password

    public LLPassword password()
    Returns the value of the `password` record component.
    Returns:
      the value of the `password` record component

  - ### roles

    public Map<LLRoleName,LLRole> roles()
    Returns the value of the `roles` record component.
    Returns:
      the value of the `roles` record component